<!DOCTYPE html>
<html lang="en">

<head>

    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Load all orders - Danh sách đơn hàng</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
</head>

<body onload="onPageLoading()">
    <div class="container-fluid pt-4">
        <h2 class="text-center pb-3">Danh sách đơn hàng</h2>
        <div class="row">
            <div class="col-sm-12" style="margin-bottom: 20px;">
                <button class="btn btn-success text-left" onclick="onBtnAddOrderClick()">Thêm đơn hàng</button>
            </div>
        </div>
        <table class="table text-center table-striped" id="table-order">
            <thead>
                <tr>
                    <th scope="col">Order Code</th>
                    <th scope="col">Kích cỡ combo</th>
                    <th scope="col">Loại pizza</th>
                    <th scope="col">Nước uống</th>
                    <th scope="col">Thành tiền</th>
                    <th scope="col">Họ và tên</th>
                    <th scope="col">Số điện thoại</th>
                    <th scope="col">Trạng thái</th>
                    <th scope="col">Chi tiết</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>

    </div>

    <script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gEND_OF_TABLE_ROW = -1;
        const gCOL_ORDER_CODE = 0;
        const gCOL_SIZE_COMBO = 1;
        const gCOL_PIZZA_TYPE = 2;
        const gCOL_DRINK = 3;
        const gCOL_TOTAL_PRIZE = 4;
        const gCOL_FULL_NAME = 5;
        const gCOL_PHONE_NUMBER = 6;
        const gCOL_STATUS = 7;
        const gCOL_ORDER_DETAIL = 8;

        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */


        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // Hàm thực hiện khi load trang
        function onPageLoading() {
            getAllOrders();
        }
        // Hàm nhấn nút thêm order chuyển sang trang create order
        function onBtnAddOrderClick() {
            const vUrlOpenToCreateOrderSite = "create.order.html";
            window.location.href = vUrlOpenToCreateOrderSite;
        }

        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // Hàm thực hiện việc load all orders từ server và load vào table
        function getAllOrders() {
            /**
           * Chia để trị - 04 bước cố gắng thành 04 functions riêng biệt
           */
            // B1: Thu thập dữ liệu (trong bài này bước này ko cần)
            // B2: Validate dữ liệu (trong bài này bước này ko cần)
            // B3: Thực hiện việc gọi API từ server Server
            var vXmlHttpGetAllOrders = new XMLHttpRequest();
            callApiToGetAllOrders(vXmlHttpGetAllOrders);

            // B4: Xử lý trên front-end khi request xử lý xong và trả về response thành công
            vXmlHttpGetAllOrders.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    loadOrderToTable(vXmlHttpGetAllOrders);
                }
            }
        }

        // hàm gọi api để lấy all orders
        function callApiToGetAllOrders(paramXMLHttpGetAllOrders) {
            const vBaseUrl = "http://203.171.20.210:8080/devcamp-pizza365/orders";
            paramXMLHttpGetAllOrders.open("GET", vBaseUrl, true);
            paramXMLHttpGetAllOrders.send();
        }

        // input: xml http request đã đươc trả lời
        // ouptut/end: dữ liệu hiên thi trên bảng
        function loadOrderToTable(paramXMLHttpAllOrder) {
            //CODE Ở ĐÂY ĐỂ LOAD DATA VÀO TABLE
            console.log(paramXMLHttpAllOrder.responseText);
            var vAllOrderObj = JSON.parse(paramXMLHttpAllOrder.responseText)

            var vTableOrder = document.getElementById("table-order")
            var vTableBody = vTableOrder.getElementsByTagName("tbody")[0];

            for (let bI = 0; bI < vAllOrderObj.length; bI++) {
                var bNewOrderRow = vTableBody.insertRow(gEND_OF_TABLE_ROW);

                var bOrderCodeCell = bNewOrderRow.insertCell(gCOL_ORDER_CODE);
                var bComboSizeCell = bNewOrderRow.insertCell(gCOL_SIZE_COMBO);
                var bPizzaTypeCell = bNewOrderRow.insertCell(gCOL_PIZZA_TYPE);
                var bDrinkCell = bNewOrderRow.insertCell(gCOL_DRINK);
                var bTotalPrize = bNewOrderRow.insertCell(gCOL_TOTAL_PRIZE);
                var bFullNameCell = bNewOrderRow.insertCell(gCOL_FULL_NAME);
                var bPhoneNumberCell = bNewOrderRow.insertCell(gCOL_PHONE_NUMBER);
                var bStatusCell = bNewOrderRow.insertCell(gCOL_STATUS);
                var bOrderDetailCell = bNewOrderRow.insertCell(gCOL_ORDER_DETAIL);

                bOrderCodeCell.innerHTML = vAllOrderObj[bI].orderCode;
                bComboSizeCell.innerHTML = vAllOrderObj[bI].kichCo;
                bPizzaTypeCell.innerHTML = vAllOrderObj[bI].loaiPizza;
                bDrinkCell.innerHTML = vAllOrderObj[bI].idLoaiNuocUong;
                bTotalPrize.innerHTML = vAllOrderObj[bI].thanhTien;
                bFullNameCell.innerHTML = vAllOrderObj[bI].hoTen;
                bPhoneNumberCell.innerHTML = vAllOrderObj[bI].soDienThoai;
                bStatusCell.innerHTML = vAllOrderObj[bI].trangThai;

                var bDetailButton = document.createElement("button");
                bDetailButton.textContent = "Chi tiết";
                bDetailButton.className = "btn btn-info order-detail";
                bDetailButton.setAttribute("data-id", vAllOrderObj[bI].id);
                bDetailButton.setAttribute("data-ordercode", vAllOrderObj[bI].orderCode);
                bOrderDetailCell.appendChild(bDetailButton);

                bDetailButton.addEventListener("click", function () {
                    onBtnOrderDetailClick(this);
                })
            }
        }

        //Hàm nhấn nút ghi chi tiết order
        function onBtnOrderDetailClick(paramOrderDetailClick) {
            var vId = paramOrderDetailClick.dataset.id;
            var vOrderCode = paramOrderDetailClick.dataset.ordercode;

            console.log("ID: ", vId);
            console.log("Order code: ", vOrderCode);

            const vDETAIL_FORM_URL = "orderDetail.html";

            var vUrlOpenToDetailSite = vDETAIL_FORM_URL + "?" + "id=" + vId + "&ordercode=" + vOrderCode;

            window.location.href = vUrlOpenToDetailSite;
        }


    </script>
</body>

</html>